#include <Arduino.h>
#include <HardwareSerial.h>
#include <WiFi.h>
#include <HTTPClient.h>
#include <Wire.h>
#include <ArduinoJson.h>
#include <EEPROM.h>
// add cl oil
#define POWER_PIN 23
#define RXD2 9
#define TXD2 10
#define LF   0x0A

#define TIME_ON  9
#define TIME_OFF 22
  /*
  Welcome to Alpha Vantage! Here is your API key: APHKXFCZU87L6KI2. Please record this API key for future access to Alpha Vantage.
  https://www.alphavantage.co/query?function=GLOBAL_QUOTE&symbol=F&apikey=APHKXFCZU87L6KI2
  {
    "Global Quote": {
        "01. symbol": "F",
        "02. open": "8.6700",
        "03. high": "8.7500",
        "04. low": "8.6200",
        "05. price": "8.7200",
        "06. volume": "51202700",
        "07. latest trading day": "2019-10-25",
        "08. previous close": "8.6000",
        "09. change": "0.1200",
        "10. change percent": "1.3953%"
    }
}
  */
/*
http://worldclockapi.com/api/json/est/now

{"$id":"1","currentDateTime":"2019-10-26T14:31-04:00","utcOffset":"-04:00:00","isDayLightSavingsTime":true,"dayOfTheWeek":"Saturday","timeZoneName":"Eastern Standard Time","currentFileTime":132165739070692995,"ordinalDate":"2019-299","serviceResponse":null}
https://github.com/PaulStoffregen/Time
*/
/*
{
    "coord": {
        "lon": -84.27,
        "lat": 34.07
    },
    "weather": [
        {
            "id": 800,
            "main": "Clear",
            "description": "clear sky",
            "icon": "01d"
        }
    ],
    "base": "stations",
    "main": {
        "temp": 52.27,
        "pressure": 1023,
        "humidity": 37,
        "temp_min": 50,
        "temp_max": 55.99
    },
    "visibility": 16093,
    "wind": {
        "speed": 2.71,
        "deg": 190
    },
    "clouds": {
        "all": 1
    },
    "dt": 1573328132,
    "sys": {
        "type": 1,
        "id": 3667,
        "country": "US",
        "sunrise": 1573301034,
        "sunset": 1573339077
    },
    "timezone": -18000,
    "id": 4179574,
    "name": "Alpharetta",
    "cod": 200
}*/
  /*ts=imperial&mode=json&q=alpharetta,US
{"$id":"1","currentDateTime":"2019-10-26T17:37-04:00","utcOffset":"-04:00:00","isDayLightSavingsTime":true,"dayOfTheWeek":"Saturday","timeZoneName":"Eastern Standard Time","currentFileTime":132165850329087198,"ordinalDate":"2019-299","serviceResponse":null}
*/
const char* ssid =     "Nobody24_2GEXT";
const char* password = "88628862";
#define  T_DATE 1
#define  T_TIME 2
#define  T_BOTH 4

#define  W_DESC 1
#define  W_HUMID 2
#define  W_WIND 3
#define  W_HIGH 4
#define  W_LOW  5

#define  DELAY  5000
#define  NSTOCKS 5

static int gDelay = 0;
int currentHour = -1;
int lastHour = -1;
static int gCount = 0;

String wDesc;
String wHumid;
String wWind;
String wHigh;
String wLow;

HTTPClient httpWeather;
HTTPClient httpTime;
HTTPClient httpStocks;

HardwareSerial s2(1) ;

const char* stocks[NSTOCKS] = { "INX", "DJI","BND","ONEQ","TLT" };
String stockVals[NSTOCKS];


char *getWeatherData( int type) {
  static char results[50];
  
  memset( results, 0, 50);
  char buff[200];
  memset(buff,0,200);  

  Serial.println("getWeather");
  httpWeather.begin("https://community-open-weather-map.p.rapidapi.com/weather?&units=imperial&mode=json&q=alpharetta,US");
  httpWeather.addHeader("x-rapidapi-host","community-open-weather-map.p.rapidapi.com");
  httpWeather.addHeader("x-rapidapi-key","43192cedeemshb0cd94fbe2e7fafp124c87jsnd84554c60bc5");

  int httpCode = httpWeather.GET();
  if (httpCode > 0) { 
 
        String payload = httpWeather.getString();
        Serial.println(httpCode);
       Serial.println(payload);
        DynamicJsonDocument doc(1000);
        DeserializationError error = deserializeJson(doc, payload);
        if (error) {
          Serial.print(F("deserializeJson() failed: "));
          Serial.println(error.c_str());
          return "";
        }
   
        if ( type == W_DESC ) {
          float wf = doc["main"]["temp"].as<float>();
          String desc = doc["weather"][0]["description"];
          sprintf(buff,"%.0f %s", wf, desc.c_str());
        }
        else if (type == W_HUMID ) {
            float wf = doc["main"]["humidity"].as<float>();
            sprintf(buff, "humidity %.0f%%", wf);
        }
        else if (type == W_WIND) {
          float wf = doc["wind"]["speed"].as<float>();
          sprintf(buff, "wind %2.1f", wf);          
        }
        else if ( type == W_LOW ) {
          float wf = doc["main"]["temp_min"].as<float>();
          sprintf(buff, "low %2.1f", wf);        
        }
        else if ( type == W_HIGH) {
          float wf = doc["main"]["temp_max"].as<float>();
          sprintf(buff, "high %2.1f", wf);        
        }        
        strcpy(results,buff);

    }else {
          Serial.println("Error on HTTP weather request");
        }

    httpWeather.end(); //Free the resources
    
   if ( strlen(results) > 16 ) {
     results[16] = 0;
   }
   return results;
}


char * getTime(int type) {
  static char results[50];
  memset( results, 0, 50);

   Serial.println("starting clock call");
    httpTime.begin("http://worldclockapi.com/api/json/est/now");

    int httpCode = httpTime.GET();

    if (httpCode > 0) {
      String payload = httpTime.getString();
        DynamicJsonDocument doc(1000);
        DeserializationError error = deserializeJson(doc, payload);
        if (error) {
          Serial.print(F("deserializeJson() failed: "));
          Serial.println(error.c_str());
          return "";
        }

        String ts = doc["currentDateTime"];
        if (type == T_TIME ) {
          strcpy(results,ts.substring(11,16).c_str());
        }
        else if ( type == T_DATE) {
              strcpy(results,ts.substring(5,10).c_str());
              results[2] = '/';
        }
        else {
          strcpy(results,ts.substring(5,10).c_str());
          results[2] = '/';
          strcat(results," ");
          strcat(  results,ts.substring(11,16).c_str());
          results[8] = '.';
        }
        return results;
         
    }
    else {
         Serial.println("Error on HTTP time request");
    }

   return results;
}

char * getStocks( const char *symbol) {
  static char results[50];
  memset( results, 0, 50);

    Serial.printf("starting stocks call for: %s\n", symbol);
    httpStocks.begin("https://www.alphavantage.co/query?function=GLOBAL_QUOTE&symbol=" +
      String(symbol) + "&apikey=APHKXFCZU87L6KI2");

    int httpCode = httpStocks.GET();
    Serial.println("code " + httpCode);

    if (httpCode > 0) {
       String payload = httpStocks.getString();
        DynamicJsonDocument doc(1000);
        DeserializationError error = deserializeJson(doc, payload);
        if (error) {
          Serial.print(F("deserializeJson() failed: "));
          Serial.println(error.c_str());
          return "";
        }

          String ts = doc["Global Quote"]["10. change percent"];
          Serial.println("STOCK=" + ts);
          sprintf(results,"%s %5.5s", symbol, ts.c_str());
        }
        return results;
         
    }

void writeByte( unsigned char val) {
  s2.write(val);
}


void writeString( const char *str) {
  Serial.printf("writeString: %s\n", str);
   for ( int idx = 0; idx < strlen(str); idx++) {
     writeByte(str[idx]);
   }
}

int currMins() {
  String currTime = getTime(T_TIME);
  Serial.printf("current time = %s\n", currTime.c_str());
  String s1 = currTime.substring(0,2);
  String s2 = currTime.substring(3,5);
  return atoi(currTime.substring(0,2).c_str())*60 +
                atoi(currTime.substring(3,5).c_str());

}

void setup() {


  //delay(3000);
  //digitalWrite(POWER_PIN,1);
   //return;
  delay(2000);

  pinMode(POWER_PIN, OUTPUT);  
  digitalWrite(POWER_PIN,0);
  delay(1000);
  Serial.begin(9600);
  s2.begin(1200, SERIAL_8N2, RXD2, TXD2);

  writeByte(LF);
  writeByte(0x0d);
  writeByte(0x13);
  delay(200);
  writeString("****************");
  delay(1000);
 
  WiFi.begin(ssid, password);
 
  while (WiFi.status() != WL_CONNECTED) {
    delay(1000);
    Serial.println("Connecting to WiFi..");
  }
 
  Serial.println("Connected to the WiFi network\n");

  currentHour = currMins();
  lastHour = currentHour;

  Serial.printf("mins = %d\n", currentHour);

  gDelay = DELAY;
  writeByte(0x0E);  
  writeByte(0x0d);
  writeByte(0x0A);
}

void delayAndClear( int time ) {
  delay(time);
  writeByte(0x0d);
  writeByte(0x0A);
  writeByte(LF);  
}


void loop() {



  int currTime = currMins();
  Serial.printf("currtime = %d lastHour = %d gCnt = %d\n", currTime, lastHour,gCount);

  if ( currTime > 0 && currTime > 8*60 && currTime < 23*60 ) {
    if (gCount > 50) {
      gCount = 0;
    }

    digitalWrite(POWER_PIN,0);
    writeString(getTime(T_BOTH));
    delayAndClear(DELAY);

    if ( gCount == 0 ) {
      Serial.println("UPDATING DATA");
      wDesc = getWeatherData(W_DESC);
      wHumid = getWeatherData(W_HUMID);
      wWind = getWeatherData(W_WIND);
      wHigh = getWeatherData(W_HIGH);
      wLow = getWeatherData(W_LOW);
      for ( int idx = 0; idx < NSTOCKS; idx++) {
          stockVals[idx] = getStocks(stocks[idx]);
      }

    }

      writeString(wDesc.c_str());
      delayAndClear(DELAY);
      writeString(wLow.c_str());
      delayAndClear(DELAY);      
      writeString(wHigh.c_str());
      delayAndClear(DELAY);
      writeString(wWind.c_str());
      delayAndClear(DELAY); 
      for (int idx = 0; idx < NSTOCKS; idx++) {
        writeString(stockVals[idx].c_str());
        delayAndClear(DELAY);
      }
      
    gCount++;    
    }
  else {
    Serial.println("POWER OFF DISPLAY");
      writeByte(0x0d);
      writeByte(0x0A);
      writeByte(LF);
      delay(1000*60*5);
     digitalWrite(POWER_PIN,1);

  }

}